﻿using System;
using System.Linq;
using System.Net.Http;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Moq;
using Rhyous.WebFramework.Clients;

namespace Example.Bug27907.Tests
{
    [TestClass]
    public class UnitTest1
    {
        [TestMethod]
        public void TestThatThrowsTheSystemMissingMethodExceptionError()
        {
            var url = "";
            var httpContent = new StringContent("");
            var mockHttpClient = new Mock<IHttpClient>();
            mockHttpClient.Setup(c=>c.PostAsync(It.IsAny<string>(),It.IsAny<HttpContent>()));
            var a = mockHttpClient.Object.PostAsync(url, httpContent);
        }

        [TestMethod]
        public void ExampleOfReflectionFailingBecauseTypesArenNotEqual()
        {
            var type = typeof(HttpContent);
            var method = typeof(IHttpClient).GetMethod("PostAsync", new[] { typeof(string), typeof(HttpContent)});

            Assert.IsNotNull(method);
        }

        [TestMethod]
        public void ExampleOfReflectionFailingBecauseTypesArenNotEqual2()
        {
            var type = typeof(HttpContent);
            var method1 = typeof(IHttpClient).GetMethod("PostAsync", new[] { typeof(string), typeof(HttpContent) });
            var method2 = typeof(HttpClient).GetMethod("PostAsync", new[] { typeof(string), typeof(HttpContent) });
            Assert.IsNotNull(method1);
            Assert.IsNotNull(method2);
        }



        [TestMethod]
        public void ExampleOfReflectionFailingBecauseTypesArenNotEqual3()
        {
            var type = typeof(HttpContent);
            var methods = typeof(IHttpClient).GetMethods().Where(m=>m.Name == "PostAsync" && m.GetParameters().Count() == 2);
            var method1 = methods.FirstOrDefault(m=>m.GetParameters().First().ParameterType == typeof(string));
            var method2 = typeof(HttpClient).GetMethod("PostAsync", new[] { typeof(string), typeof(HttpContent) });
            Assert.IsNotNull(method1);
            Assert.IsNotNull(method2);
            Assert.AreEqual(method1.GetParameters()[0].ParameterType, method2.GetParameters()[0].ParameterType);
            Assert.AreEqual(method1.GetParameters()[1].ParameterType, method2.GetParameters()[1].ParameterType);
        }
    }
}
